ServerEvents.recipes(event => {
  event.remove({id: 'productivebees:bee_cage'})
  event.remove({id: 'productivebees:nest_locator'})
  event.remove({id: 'productivebees:upgrades/base'})
  event.remove({output: 'minecraft:beehive'})
  event.remove({output: 'productivebees:centrifuge'})
  event.remove({id: 'productivebees:powered_centrifuge/mekanism'})
  event.remove({id: 'productivebees:powered_centrifuge/thermal'})
  event.remove({id: 'centrifugetiersreproduced:allthecompressed/high_end_centrifuge'})
  event.remove({id: 'centrifugetiersreproduced:allthecompressed/creative_centrifuge'})
  event.remove({id: 'productivebees:bee_fishing/sponge_bee'})
  event.remove({id: 'productivebees:bee_fishing/prismarine_bee'})
  event.remove({id: 'productivebees:bee_spawning/draconic_obsidian_nest'})
  event.remove({id: 'productivebees:bee_spawning/crystalline_nether_quartz_nest'})
  event.remove({id: 'productivebees:bee_spawning/gold_nether_gold_nest'})
  event.remove({id: 'productivebees:bee_spawning/ender_end_stone_nest'})
  event.remove({id: 'productivebees:bee_spawning/ghostly_soul_sand_nest'})
  event.remove({id: 'productivebees:bee_spawning/glowing_glowstone_nest'})
  event.remove({id: 'productivebees:mysticalagriculture/awakaned_supremium_bee'})
  event.remove({id: 'productivebees:mysticalagriculture/imperium_bee'})
  event.remove({id: 'productivebees:mysticalagriculture/inferium_bee'})
  event.remove({id: 'productivebees:mysticalagriculture/insanium_bee'})
  event.remove({id: 'productivebees:mysticalagriculture/prudentium_bee'})
  event.remove({id: 'productivebees:mysticalagriculture/supremium_bee'})
  event.remove({id: 'productivebees:mysticalagriculture/tertium_bee'})
  event.remove({id: 'productivebees:pneumaticcraft/compressed_iron_bee'})
  event.remove({id: 'productivebees:cofh/machine/smelter/blaze_bee_to_blitz_bee'})
  event.remove({id: 'productivebees:cofh/machine/smelter/blaze_bee_to_basaltz_bee'})
  event.remove({id: 'productivebees:cofh/shaped/blaze_bee_to_blitz_bee'})
  event.remove({id: 'productivebees:cofh/machine/smelter/redstone_bee_to_destabilized_redstone_bee'})
  event.remove({id: 'productivebees:cofh/shaped/redstone_bee_to_destabilized_redstone_bee'})
  event.remove({id: 'productivebees:cofh/machine/smelter/glowing_bee_to_energized_glowstone_bee'})
  event.remove({id: 'productivebees:cofh/shaped/glowing_bee_to_energized_glowstone_bee'})
  event.remove({id: 'productivebees:cofh/machine/smelter/ender_bee_to_resonant_ender_bee'})
  event.remove({id: 'productivebees:cofh/shaped/ender_bee_to_resonant_ender_bee'})
  event.remove({id: 'productivebees:cofh/shaped/blaze_bee_to_blizz_bee'})
  event.remove({id: 'productivebees:cofh/shaped/blaze_bee_to_basaltz_bee'})
  event.remove({id: 'productivebees:cofh/machine/smelter/gold_bee_to_rose_gold_bee'})
  event.remove({id: 'productivebees:botania/pure_bee'})
  event.remove({id: 'productivebees:botania/mana_bee'})
  event.remove({id: 'productivebees:mekanism/wasted_radioactive_bee'})
  event.remove({id: 'productivebees:elementalcraft/drenched_iron_bee'})
  event.remove({id: 'productivebees:powah/energized_steel_bee'})
  event.remove({id: 'productivebees:powah/spirited_crystal_bee'})
  event.remove({id: 'productivebees:botania/manasteel_bee'})
  event.remove({id: 'productivebees:ars_nouveau/arcane_bee'})
  event.remove({id: 'productivebees:evilcraft/bloody_bee_2'})
  event.remove({id: 'productivebees:spawn_egg_hoarder_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/dragonsteel_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/dragonsteel_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/shellite_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/shellite_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/destabilized_redstone_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/redstone_bee_to_destabilized_redstone_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/blaze_bee_to_basaltz_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/blaze_bee_to_basaltz_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/energized_glowstone_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/glowing_bee_to_energized_glowstone_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/soul_infused_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/soul_infused_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/resonant_ender_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/ender_bee_to_resonant_ender_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/gold_bee_to_rose_gold_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/twinite_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/twinite_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/blaze_bee_to_blitz_bee'})
  event.remove({id: 'productivebees:thermal/machine/smelter/blaze_bee_to_blitz_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/stellarium_bee'})
  event.remove({id: 'productivebees:thermal/shapeless/melodium_bee'})
  event.remove({id: 'productivebees:naturesaura/altar/infused_iron_bee'})
  event.remove({id: 'productivebees:naturesaura/altar/tainted_gold_bee'})
  event.remove({id: 'productivebees:enderio/dark_steel_bee'})
  event.remove({id: 'productivebees:enderio/energetic_alloy_bee'})
  event.remove({id: 'productivebees:centrifuge/evilcraft/honeycomb_bloody'})
  event.remove({type: 'productivebees:bee_conversion', mod: 'productivebees' })
  event.remove({type: 'productivebees:bee_breeding', mod: 'productivebees' })
  event.remove({type: 'create:mixing', mod: 'productivebees' })
})

ServerEvents.recipes(event => {
  //Bee Cage
  event.shaped('productivebees:bee_cage',
  ['   ','121','   '], {
      1: '#forge:treated_wood',
      2: 'minecraft:honey_bottle'
  }).id('productivebees:bee_cage')
  
  //Nest Locator
  event.shaped('productivebees:nest_locator',
  ['121','131','111'], {
      1: '#forge:nuggets/brass',
      3: 'immersiveengineering:steel_scaffolding_standard',
      2: 'minecraft:iron_bars'
  }).id('productivebees:nest_locator')
  
  //Basic Bee Hive
  event.shaped('minecraft:beehive',
  ['111','222','111'], {
      1: '#forge:treated_wood',
      2: '#forge:honeycombs'
  }).id('minecraft:beehive')
  
  //Basic Centrifuge
  event.shaped('productivebees:centrifuge',
  ['1 1','121','111'], {
      1: '#forge:ingots/steel',
      2: 'enderio:sentient_ender'
  }).id('productivebees:centrifuge')
  
  //Powered Centrifuge
  event.shaped('productivebees:powered_centrifuge',
  ['121','232','141'], {
      1: '#forge:dusts/redstone',
      2: '#forge:ingots/iron',
      3: 'productivebees:centrifuge',
      4: 'enderio:octadic_capacitor'
  }).id('productivebees:powered_centrifuge')
  
  //Upgrade Base
  event.shaped('productivebees:upgrade_base',
  ['121','232','141'], {
      1: 'aether:enchanted_berry',
      2: '#forge:gems/emerald',
      3: 'productivebees:honey_treat',
      4: 'minecraft:netherite_ingot'
  }).id('productivebees:upgrade_base')
  
  //High End Centrifuge
  event.shaped('centrifugetiersreproduced:high_end_centrifuge',
  ['121','232','121'], {
      1: '#forge:storage_blocks/source_steel',
      2: 'pneumaticcraft:printed_circuit_board',
      3: 'productivebees:heated_centrifuge'
  }).id('centrifugetiersreproduced:high_end_centrifuge')
  
  //Creative Centrifuge
  event.shaped('centrifugetiersreproduced:creative_centrifuge',
  ['121','232','121'], {
      1: Item.of('extendedcrafting:singularity', {"Id": "extendedcrafting:ultimate_honeycomb"}).strongNBT().toJson(),
      2: 'kubejs:ultimate_honeycomb',
      3: 'centrifugetiersreproduced:cosmic_centrifuge'
  }).id('centrifugetiersreproduced:creative_centrifuge')

  //Expansion Boxes
  event.replaceInput(
      { output: '#productivebees:expansion_boxes' }, // Arg 1: the filter
      'minecraft:honeycomb',            // Arg 2: the item to replace
      'minecraft:beehive'         // Arg 3: the item to replace it with
    )

  //Advanced Hives
  event.replaceInput(
      { output: '#productivebees:advanced_beehives' }, // Arg 1: the filter
      'minecraft:honeycomb',            // Arg 2: the item to replace
      'minecraft:beehive'         // Arg 3: the item to replace it with
  )

  //Compressed Iron Bee - Pressure Chamber
  event.custom({
    "type": "pneumaticcraft:pressure_chamber", 
      "inputs": [
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:dark_steel\"}}"
        },
    ],
          "pressure": 2.5, 
          "results": [
            {
              "type": "forge:nbt",
              "item": "productivebees:spawn_egg_configurable_bee",
              "count": 1,
              "nbt": "{EntityTag:{type:\"productivebees:compressed_iron\"}}"
            }]
  }).id('productivebees:pressure/compressed_iron_bee')

  //Mana Steel Bee
  event.recipes.botania.mana_infusion(
  {
    "type": "forge:nbt",
    "item": "productivebees:spawn_egg_configurable_bee",
    "count": 1,
    "nbt": "{EntityTag:{type:\"productivebees:manasteel\"}}"
  },
  {
    "type": "forge:nbt",
    "item": "productivebees:spawn_egg_configurable_bee",
    "count": 1,
    "nbt": "{EntityTag:{type:\"productivebees:ludicrite\"}}"
  }, 3000).id('productivebees:mana_infusion/manasteel')

  //Iesnium Bee
  event.recipes.occultism.ritual(
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:iesnium\"}}"
    },
    [
      "#forge:storage_blocks/iesnium",
      "#forge:storage_blocks/iesnium",
      "#forge:storage_blocks/iesnium",
      "#forge:storage_blocks/iesnium",
    ],
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:diamond\"}}"
    },
    'occultism:craft_afrit'
    ).duration("40").id('productivebees:occultism/iesnium_bee')

    //Spirited Crystal Bee
    event.recipes.powah.energizing(["powah:spirited_crystal_block",
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:niotic_crystal\"}}"
    },
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:terrasteel\"}}"
    },
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:niotic_crystal\"}}"
    },
    "powah:spirited_crystal_block"],     
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:spirited_crystal\"}}"
    }, 10000000).id(`productivebees:powah/spirited_crystal`)

    //Energized Steel Bee
    event.recipes.powah.energizing(["powah:energized_steel_block",
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:steel\"}}"
    },
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:allthemodium\"}}"
    },
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:steel\"}}"
    },
    "powah:energized_steel_block"],     
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:energized_steel\"}}"
    }, 100000).id(`productivebees:powah/energized_steel`)

    //Niotic Crystal Bee
    event.recipes.powah.energizing(["powah:niotic_crystal_block",
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:blazing_crystal\"}}"
    },
    "botania:mana_diamond_block",
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:blazing_crystal\"}}"
    },
    "powah:niotic_crystal_block"],     
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:niotic_crystal\"}}"
    }, 9000000).id(`productivebees:powah/niotic_crystal`)

    //Swift Alloy Bee
    event.custom({
        "type": "elementalcraft:binding",
        "element_amount": 1250,
        "element_type": "air",
        "ingredients": [
          {
          "item": "rats:oratchalcum_block",
          },
          {
            "type": "forge:nbt",
            "item": "productivebees:spawn_egg_configurable_bee",
            "count": 1,
            "nbt": "{EntityTag:{type:\"productivebees:drenched_iron\"}}"
          },
          {
          "item": "occultism:spirit_attuned_gem",
          },
          {
            "type": "forge:nbt",
            "item": "productivebees:spawn_egg_configurable_bee",
            "count": 1,
            "nbt": "{EntityTag:{type:\"productivebees:redstone\"}}"
          },
          {
            "type": "forge:nbt",
            "item": "productivebees:spawn_egg_configurable_bee",
            "count": 1,
            "nbt": "{EntityTag:{type:\"productivebees:air_crystal\"}}"
          }
        ],
        "output": {
            "type": "forge:nbt",
            "item": "productivebees:spawn_egg_configurable_bee",
            "count": 1,
            "nbt": "{EntityTag:{type:\"productivebees:swift_alloy\"}}"
          }
      }).id('productivebees:elementalcraft/swift_alloy_bee')

  //Utheric Bee Egg
  event.custom({ 
    "type": "ars_nouveau:enchanting_apparatus",
    "reagent": [{
        "type": "forge:nbt", 
        "item": "productivebees:spawn_egg_configurable_bee", 
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:cloggrum\"}}"
      }],
    "pedestalItems": [ 
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}},
      {"item": {"item": "undergarden:utherium_block"}}
    ],
    "output": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:utheric\"}}"
    },
    "sourceCost": 10000,
    "keepNbtOfReagent": false
    }).id('productivebees:enchanting_apparatus/utheric_bee_egg')

    //Arcane Bee Egg
    event.custom({
      "type": "ars_nouveau:enchanting_apparatus",
      "reagent": [{
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:diamond\"}}"
        }],
      "pedestalItems": [
        {"item": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:amethyst\"}}"
        }},
        {"item": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:amethyst\"}}"
        }},
        {"item": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:amethyst\"}}"
        }},
        {"item": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:amethyst\"}}"
        }}
      ],
      "output": {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:arcane\"}}"
      },
      "sourceCost": 10000,
      "keepNbtOfReagent": false
      }).id('productivebees:enchanting_apparatus/arcane_bee_egg')

    //Cloggrum Bee Egg
    event.custom({
      "type": "mysticalagriculture:infusion","conditions": [{"type": "mysticalagriculture:augment_enabled","augment": "kubejs:tier2_crafting_seed"},{"type": "mysticalagriculture:augment_enabled","augment": "mysticalagriculture:nature_seeds"}],
      "input": {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:steel\"}}"
      },
      "ingredients": [
        {"item": "undergarden:cloggrum_block"},
        {"item": "undergarden:catalyst"},
        {"item": "undergarden:cloggrum_block"},
        {"item": "undergarden:catalyst"},
        {"item": "undergarden:cloggrum_block"},
        {"item": "undergarden:catalyst"},
        {"item": "undergarden:cloggrum_block"},
        {"item": "undergarden:catalyst"}],
      "result": {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:cloggrum\"}}"
      }
    }).id('productivebees:infusion/cloggrum_bee_egg')

    //Bee Mixer Recipe Structure
    function beeMixer(inputs, output){
    event.custom({
      "type": "create:mixing", "ingredients": inputs,
      "results": [
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:" + output +"\"}}"
        }
      ],
      "heatRequirement": "heated" 
      }).id('productivebees:mixing/' + output +'_bee_egg')
    }

    //Bee Mixer Recipe - Inputs - Bee Out
    beeMixer([{"item": "allthecompressed:stone_2x", "count": 4}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'stone')
    beeMixer([{"item": "architects_palette:ender_pearl_block", "count": 64}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'ender')
    beeMixer([{"item": "allthecompressed:redstone_block_2x", "count": 4}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'redstone')
    beeMixer([{"item": "allthecompressed:lapis_block_2x", "count": 4}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'lapis')
    beeMixer([{"item": "allthecompressed:glowstone_3x", "count": 4}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'glowing')
    beeMixer([{"item": "allthecompressed:quartz_block_3x", "count": 4}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'crystalline')
    beeMixer([{"item": "allthecompressed:obsidian_2x", "count": 4}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'obsidian')
    beeMixer([{"item": "botania:blaze_block", "count": 32}, {"tag": "forge:storage_blocks/honeycombs","count": 16}], 'blazing')

    //Alloy Kiln Bee Recipe Structure
    function beeKiln(output, input1, input2) {
      event.custom({"type":"immersiveengineering:alloy",
      "input0": input1,
      "input1":
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:" + input2 + "\"}}"
        },
      "result":{"base_ingredient":
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:" + output + "\"}}"
        },"count":1
      },"time":200}).id('productivebees:kiln/' + output +'_bee_egg')
    }

    //Alloy Kiln Bee Recipe - Bee Out - Block In - Bee In
    beeKiln('aluminum', { "base_ingredient": {"tag":"forge:storage_blocks/aluminum"},"count": 16}, 'stone')
    beeKiln('coal', { "base_ingredient": {"tag":"forge:storage_blocks/coal"},"count": 16}, 'stone')
    beeKiln('copper', { "base_ingredient": {"tag":"forge:storage_blocks/copper"},"count": 16}, 'stone')
    beeKiln('diamond', { "base_ingredient": {"tag":"forge:storage_blocks/diamond"},"count": 16}, 'stone')
    beeKiln('emerald', { "base_ingredient": {"tag":"forge:storage_blocks/emerald"},"count": 16}, 'stone')
    beeKiln('gold', { "base_ingredient": {"tag":"forge:storage_blocks/gold"},"count": 16}, 'stone')
    beeKiln('iron', { "base_ingredient": {"tag":"forge:storage_blocks/iron"},"count": 16}, 'stone')
    beeKiln('lead', { "base_ingredient": {"tag":"forge:storage_blocks/lead"},"count": 16}, 'stone')
    beeKiln('nickel', { "base_ingredient": {"tag":"forge:storage_blocks/nickel"},"count": 16}, 'stone')
    beeKiln('osmium', { "base_ingredient": {"tag":"forge:storage_blocks/osmium"},"count": 16}, 'stone')
    beeKiln('platinum', { "base_ingredient": {"tag":"forge:storage_blocks/platinum"},"count": 16}, 'stone')
    beeKiln('silver', { "base_ingredient": {"tag":"forge:storage_blocks/silver"},"count": 16}, 'stone')
    beeKiln('tin', { "base_ingredient": {"tag":"forge:storage_blocks/tin"},"count": 16}, 'stone')
    beeKiln('zinc', { "base_ingredient": {"tag":"forge:storage_blocks/zinc"},"count": 16}, 'stone')
    beeKiln('amethyst', { "base_ingredient": {"tag":"forge:storage_blocks/amethyst"},"count": 64}, 'stone')

    //Element Infusion Bee Recipe Structure
    function beeInfusion(input, output, element, amount){
      event.custom({
        "type": "elementalcraft:infusion",
        "element_amount": amount,
        "element_type": element,
        "input": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": {
            "EntityTag": {
              "type": "productivebees:" + input
            }
          }
        },
        "output": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": {
            "EntityTag": {
              "type": "productivebees:" + output
            }
          }
        }
      }).id('productivebees:elementalcraft/' + output +'_bee_egg')
    }

    //Element Infusion Bee Recipe - Input - Output - Element - Amount
    beeInfusion('conductive_alloy', 'drenched_iron', 'water', 30000)
    beeInfusion('inert_crystal', 'water_crystal', 'water', 15000)
    beeInfusion('inert_crystal', 'fire_crystal', 'fire', 15000)
    beeInfusion('inert_crystal', 'earth_crystal', 'earth', 15000)
    beeInfusion('inert_crystal', 'air_crystal', 'air', 15000)

    //Natures Aura Altar Bees
    function beeNaturesAltar(input, output, aura, time){
      event.custom({
        type: 'naturesaura:altar',
            input:{
              "type": "forge:nbt",
              "item": "productivebees:spawn_egg_configurable_bee",
              "nbt": {
                "EntityTag": {
                  "type": "productivebees:" + input
                }
              }
            },
            output: {
              "type": "forge:nbt",
              "item": "productivebees:spawn_egg_configurable_bee",
              "nbt": {
                "EntityTag": {
                  "type": "productivebees:" + output
                }
              }
            },
            aura: aura,
            time: time,
        }).id('productivebees:natures_aura/altar/' + output + '_bee_egg')
    }

    //Input Bee - Output Bee - Aura - Time
    beeNaturesAltar('steel', 'inert_crystal', 20000, 250)
    beeNaturesAltar('dark_steel', 'infused_iron', 20000, 250)
    beeNaturesAltar('energetic_alloy', 'tainted_gold', 20000, 250)

    function beeAlloySmelter(energy, input1, input2, input3, output) {
      event.custom({
          "type": "enderio:alloy_smelting",
          "energy": energy,
          "experience": 0.3,
          "inputs": [
            {
              "count": 1,
              "ingredient": {
                "type": "forge:nbt",
                "item": "productivebees:spawn_egg_configurable_bee",
                "nbt": {
                  "EntityTag": {
                    "type": "productivebees:" + input1
                  }
                }
              }
            },
            {
              "count": 1,
              "ingredient": {
                "type": "forge:nbt",
                "item": "productivebees:spawn_egg_configurable_bee",
                "nbt": {
                  "EntityTag": {
                    "type": "productivebees:" + input2
                  }
                }
              }
            },
            {
              "count": 1,
              "ingredient": {
                "type": "forge:nbt",
                "item": "productivebees:spawn_egg_configurable_bee",
                "nbt": {
                  "EntityTag": {
                    "type": "productivebees:" + input3
                  }
                }
              }
            }
          ],
          "result": {
            "type": "forge:nbt",
            "item": "productivebees:spawn_egg_configurable_bee",
            "nbt": {
              "EntityTag": {
                "type": "productivebees:" + output
              }
            }
          }
        })
    }

    //Energy - Input 1 - Input 2 - Input 3 - Output
    beeAlloySmelter(64000, 'steel', 'coal', 'obsidian', 'dark_steel')
    beeAlloySmelter(64000, 'redstone', 'arcane_gold', 'glowing', 'energetic_alloy')


        //Fluid Transposer Bee Recipe Structure
        function beeTransposer(input, output, fluid, amount){
          event.custom({
            type: 'pneumaticcraft:thermo_plant',
            fluid_input: { type: 'pneumaticcraft:fluid', fluid: fluid, amount: amount },
            item_input: Item.of('productivebees:spawn_egg_configurable_bee', '{EntityTag:{type:\"productivebees:' + input + '\"}}').strongNBT().toJson(),
            item_output: Item.of('productivebees:spawn_egg_configurable_bee', '{EntityTag:{type:\"productivebees:' + output + '\"}}'),
            pressure: 3.5,
            speed: 0.8
          }).id('productivebees:fluid_transposer/' + output +'_bee_egg')
        }

        //Fluid Transposer Bee Recipe - Input - Output - Fluid - Amount
        beeTransposer('ender', 'resonant_ender', 'thermal:ender', 8000)
        beeTransposer('glowing', 'energized_glowstone', 'thermal:glowstone', 8000)
        beeTransposer('redstone', 'destabilized_redstone', 'thermal:redstone', 8000)
        beeTransposer('plastic', 'silicon', 'industrialforegoing:latex', 8000)
        beeTransposer('compressed_iron', 'quartz_enriched_iron', 'pneumaticcraft:plastic', 8000)
        beeTransposer('crystalline', 'plastic', 'industrialforegoing:latex', 8000)
        beeTransposer('coal', 'dark_gem', 'evilcraft:blood', 8000)
        beeTransposer('dark_gem', 'bloody', 'evilcraft:blood', 16000)

  //Lumber Bee - Natural Spawn
  event.custom({
    "type": "productivebees:bee_spawning",
    "ingredient": {
        "item": "productivebees:oak_wood_nest"
    },
    "results": [
        {
            "bee": "productivebees:lumber_bee"
        }
    ]
  }).id('productivebees:bee_spawning/lumber_bee')

  //Quarry Bee - Natural Spawn
  event.custom({
    "type": "productivebees:bee_spawning",
    "ingredient": {
        "item": "productivebees:stone_nest"
    },
    "results": [
        {
            "bee": "productivebees:quarry_bee"
        }
    ]
  }).id('productivebees:bee_spawning/quarry_bee')

  //Refined Glowstone Bee Egg
  event.custom(
    {
      "type": "mekanism:compressing",
      "chemicalInput": {
        "amount": 1,
        "gas": "mekanism:osmium"
      },
      "itemInput": {
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:glowing\"}}"
        }
      }, 
      "output": {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:refined_glowstone\"}}"
      }
    })

  //Refined Obsidian Bee Egg
  event.custom(
    {
      "type": "mekanism:compressing",
      "chemicalInput": {
        "amount": 1,
        "gas": "mekanism:osmium"
      },
      "itemInput": {
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:obsidian\"}}"
        }
      }, 
      "output": {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:refined_obsidian\"}}"
      }
    })

  //Arc Furnace Bee Recipe Structure
  function beeArcFurnace(input, output, additive, energy){
    event.custom({
      "type": "immersiveengineering:arc_furnace",
      "additives": additive,
      "energy": energy,
      "input":       
      {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:" + input + "\"}}"
      },
      "results": [
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:" + output + "\"}}"
        }
      ],
      "slag": {
        "tag": "forge:slag"
      },
      "time": 400
    }).id('productivebees:immersiveengineering/' + output +'_bee')
  }

  //Arc Furnace Bee Recipe - Input - Output - Additive - Energy
  beeArcFurnace('steel', 'netherite', [{"item": "allthecompressed:netherite_block_1x", "count": 1}], 204800)
  beeArcFurnace('iron', 'steel', [{"item": "allthecompressed:steel_block_2x", "count": 1}], 204800)
  beeArcFurnace('copper', 'brass', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:zinc\"}}"}], 204800)
  beeArcFurnace('copper', 'bronze', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:tin\"}}"}], 204800)
  beeArcFurnace('copper', 'constantan', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:nickel\"}}"}], 204800)
  beeArcFurnace('gold', 'electrum', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:silver\"}}"}], 204800)
  beeArcFurnace('iron', 'invar', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:nickel\"}}"}], 204800)
  beeArcFurnace('copper', 'rose_gold', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:gold\"}}"}], 204800)
  beeArcFurnace('blazing', 'blitz', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:glowing\"}}"}], 204800)
  beeArcFurnace('blazing', 'basalz', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:coal\"}}"}], 204800)
  beeArcFurnace('ender', 'enderium', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:diamond\"}}"}, {"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:lead\"}}"}], 512000)
  beeArcFurnace('glowing', 'lumium', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:silver\"}}"}, {"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:tin\"}}"}], 512000)
  beeArcFurnace('redstone', 'signalum', [{"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:silver\"}}"}, {"type": "forge:nbt","item": "productivebees:spawn_egg_configurable_bee","count": 1,"nbt": "{EntityTag:{type:\"productivebees:copper\"}}"}], 512000)

  //Allthemodium Bee Egg
  event.custom({
    "type": "naturesaura:offering",
    "input":      
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:netherite\"}}"
    },
    "start_item": 
    {
      "item": "allthecompressed:allthemodium_block_1x"
    },
    "output":
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:allthemodium\"}}"
    }
}).id('productivebees:naturesaura/allthemodium_bee')

//Vibranium Bee Egg
event.custom({
  "type": "naturesaura:offering",
  "input":      
  {
    "type": "forge:nbt",
    "item": "productivebees:spawn_egg_configurable_bee",
    "count": 1,
    "nbt": "{EntityTag:{type:\"productivebees:allthemodium\"}}"
  },
  "start_item": 
  {
    "item": "allthecompressed:vibranium_block_1x"
  },
  "output":
  {
    "type": "forge:nbt",
    "item": "productivebees:spawn_egg_configurable_bee",
    "count": 1,
    "nbt": "{EntityTag:{type:\"productivebees:vibranium\"}}"
  }
  }).id('productivebees:naturesaura/vibranium_bee')

  //Unobtainium Bee Egg
  event.custom({
    "type": "naturesaura:offering",
    "input":      
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:vibranium\"}}"
    },
    "start_item": 
    {
      "item": "allthecompressed:unobtainium_block_1x"
    },
    "output":
    {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "count": 1,
      "nbt": "{EntityTag:{type:\"productivebees:unobtainium\"}}"
    }
  }).id('productivebees:naturesaura/unobtainium_bee')

  
    //Pure Daisy
    event.recipes.botania.petal_apothecary(
      {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "count": 1,
        "nbt": "{EntityTag:{type:\"productivebees:mana\"}}"
      }, [
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:manasteel\"}}"
        },
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:terrasteel\"}}"
        },
        {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "count": 1,
          "nbt": "{EntityTag:{type:\"productivebees:elementium\"}}"
        }]).id('productivebees:iceandfire/mana_bee')

  //Withered Bee - Alloy Smelter
  event.custom({
    "type": "enderio:alloy_smelting",
    "energy": 4800,
    "experience": 0.3,
    "inputs": [
      {
        "count": 1,
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": "{EntityTag:{type:\"productivebees:skeletal\"}}"
        }
      },
      {
        "count": 3,
        "ingredient": {
          "item": "minecraft:wither_skeleton_skull"
        }
      },
      {
        "count": 4,
        "ingredient": {
          "item": "minecraft:soul_sand"
        }
      }
    ],
    "result": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "nbt": {
        "EntityTag": {
          "type": "productivebees:withered"
        }
      }
    }
  })

  //Skeletal Bee - Soul Binder
  event.custom({
    "type": "enderio:soul_binding",
    "energy": 4800,
    "entity_type": "minecraft:skeleton",
    "exp": 16,
    "input":
      {
        "count": 1,
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": "{EntityTag:{type:\"productivebees:stone\"}}"
        }
      },
    "output": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "nbt": {
        "EntityTag": {
          "type": "productivebees:skeletal"
        }
      }
    }
  })

  //Ghostly Bee - Soul Binder
  event.custom({
    "type": "enderio:soul_binding",
    "energy": 4800,
    "entity_type": "minecraft:ghast",
    "exp": 16,
    "input":
      {
        "count": 1,
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": "{EntityTag:{type:\"productivebees:stone\"}}"
        }
      },
    "output": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "nbt": {
        "EntityTag": {
          "type": "productivebees:ghostly"
        }
      }
    }
  })

  //Creeper Bee - Soul Binder
  event.custom({
    "type": "enderio:soul_binding",
    "energy": 4800,
    "entity_type": "minecraft:creeper",
    "exp": 16,
    "input":
      {
        "count": 1,
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": "{EntityTag:{type:\"productivebees:stone\"}}"
        }
      },
    "output": {
          "item": "productivebees:spawn_egg_creeper_bee"
    }
  })

  //Draconic Bee - Alloy Smelter
  event.custom({
    "type": "enderio:alloy_smelting",
    "energy": 4800,
    "experience": 0.3,
    "inputs": [
      {
        "count": 1,
        "ingredient": {
          "type": "forge:nbt",
          "item": "productivebees:spawn_egg_configurable_bee",
          "nbt": "{EntityTag:{type:\"productivebees:ender\"}}"
        }
      },
      {
        "count": 4,
        "ingredient": {
          "item": "apotheosis:infused_breath"
        }
      }
    ],
    "result": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "nbt": {
        "EntityTag": {
          "type": "productivebees:draconic"
        }
      }
    }
  })

  //Cyanite Bee - Conversion
  event.custom({
    "type": "productivebees:item_conversion",
    "bee": "productivebees:radioactive",
    "ingredients": [
      {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "nbt": {
          "EntityTag": {
            "type": "productivebees:radioactive"
          }
        }
      }
    ],
    "result": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "nbt": {
        "EntityTag": {
          "type": "productivebees:cyanite"
        }
      }
    }
  })

  //Radioactive Bee - Conversion
  event.custom({
    "type": "productivebees:item_conversion",
    "bee": "productivebees:creeper_bee",
    "ingredients": [
      {
        "type": "forge:nbt",
        "item": "productivebees:spawn_egg_configurable_bee",
        "nbt": {
          "EntityTag": {
            "type": "productivebees:iron"
          }
        }
      }
    ],
    "result": {
      "type": "forge:nbt",
      "item": "productivebees:spawn_egg_configurable_bee",
      "nbt": {
        "EntityTag": {
          "type": "productivebees:radioactive"
        }
      }
    }
  })
});